/* -*- c++ -*- */
/* 
 * Copyright 2019 Jay Arrowfield.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <gnuradio/io_signature.h>
#include <regex>
#include "squelch_impl.h"

namespace gr {
  namespace jay {

    squelch::sptr
    squelch::make(float initValue, float alpha)
    {
      return gnuradio::get_initial_sptr
        (new squelch_impl(initValue, alpha));
    }

    /*
     * The private constructor
     */
	
    squelch_impl::squelch_impl(float initValue, float alpha)
      : gr::sync_block("squelch",
              gr::io_signature::make(1, 1, sizeof(float)),
              gr::io_signature::make(1, 1, sizeof(float)))
	  , m_gain_target(initValue)
	  , m_gain(0.0f)
	  , m_alpha(alpha)
    {
		m_msg_port_in = pmt::mp("control");
		message_port_register_in(m_msg_port_in);
		set_msg_handler(m_msg_port_in, boost::bind(&squelch_impl::on_message, this, _1));		
	}

    /*
     * Our virtual destructor.
     */
	squelch_impl::~squelch_impl()
    {
    }
	
	void squelch_impl::print_pair(pmt::pmt_t pair)
	{
		pmt::pmt_t key = pmt::car(pair);
		pmt::pmt_t val = pmt::cdr(pair);
		
		if (pmt::is_integer(val))
		{
			fprintf(stderr, "[%s=%d]", pmt::symbol_to_string(key).c_str(), (int)pmt::to_long(val));
		}
		else if (pmt::is_real(val))
		{
			fprintf(stderr, "[%s=%f]", pmt::symbol_to_string(key).c_str(), pmt::to_float(val));
		}
		else if (pmt::is_bool(val))
		{
			fprintf(stderr, "[%s=%d]", pmt::symbol_to_string(key).c_str(), pmt::to_bool(val));
		}
		fprintf(stderr, "\n");
	}
	
	void squelch_impl::check_pair(pmt::pmt_t pair)
	{
		pmt::pmt_t key = pmt::car(pair);
		pmt::pmt_t val = pmt::cdr(pair);
		
		// Check pair for data
		if (pmt::symbol_to_string(key) == std::string("gain"))
		{
			m_gain_target = pmt::to_float(val);
		}
	}

	void squelch_impl::on_message(pmt::pmt_t msg)
	{
		if (pmt::is_dict(msg))
		{
			pmt::pmt_t items = pmt::dict_items(msg);
			try
			{
				size_t len_items = pmt::length(items);
				for (int i=0; i < len_items; i++)
				{	
					pmt::pmt_t pair = pmt::nth(i, items);
					check_pair(pair);
				}
			}
			catch (const std::exception& e)
			{
				check_pair(msg);
			}
		}
	}

	int
    squelch_impl::work(int noutput_items,
        gr_vector_const_void_star &input_items,
        gr_vector_void_star &output_items)
    {
      const float *in = (const float *) input_items[0];
      float *out = (float *) output_items[0];

	  m_gain = (1.f-m_alpha)*m_gain + m_alpha*m_gain_target;
	  
      // Do <+signal processing+>
	  for (int i=0; i < noutput_items; i++)
	  {
		  *(out++) = *(in++) * m_gain;
	  }

      // Tell runtime system how many output items we produced.
      return noutput_items;
    }

  } /* namespace jay */
} /* namespace gr */

